Subject: Re: linux-next: alacrity tree build failure

From: Greg KH <[email-masked]>
Date: Tue, 24 Nov 2009 16:51:16 -0800

On Tue, Nov 24, 2009 at 04:41:05PM -0800, Jeremy Fitzhardinge wrote:
> On 11/23/09 23:58, Stephen Rothwell wrote:
> > Today's linux-next build (x86_6 _allmodconfig) failed like this:
> >
> > drivers/vbus/built-in.o:(.data+0x0): multiple definition of `dev_attr_modalias'
> > drivers/xen/built-in.o:(.data+0x46d0): first defined here
> >
> > Caused by commit 59aa8f441d27c8470764a513dafa46a77f33e953 ("vbus: add
> > autoprobe capability to guest").  The DEVICE_ATTR(modalias ...) should
> > probably be static.  I should probably be static in
> > drivers/xen/xenbus/xenbus_probe.c as well.
> >   
> 
> All those DEVICE_ATTR()s should be static in that case.  Indeed, I guess
> they should be almost universally?  Should DEVICE_ATTR() include the
> static?  (Hm, almost every instance in the kernel already has static; it
> should probably have been part of the definition from the start, but
> changing it now would cause a lot of churn.)

There are some "non static" usages, mostly to deal with stuff within a
module that takes more than one file.  They could probably all be fixed
up if someone really is bored :)

thanks,

greg k-h